#ifndef __MODPROBE_H
#define __MODPROBE_H

#ifndef MODULE_DIR
#define MODULE_DIR "/lib/modules"
#endif

struct module_options
{
	struct module_options *next;
	char *modulename;
	char *options;
};

struct module_command
{
	struct module_command *next;
	char *modulename;
	char *command;
};

struct module_alias
{
	struct module_alias *next;
	char *module;
};

struct module_blacklist
{
	struct module_blacklist *next;
	char *modulename;
};

struct module_alias *
apply_blacklist(const struct module_alias *aliases,
		const struct module_blacklist *blacklist);

int read_config(const char *filename,
		       const char *name,
		       int dump_only,
		       int removing,
		       struct module_options **options,
		       struct module_command **commands,
		       struct module_alias **aliases,
		       struct module_blacklist **blacklist);

void read_toplevel_config(const char *filename,
				 const char *name,
				 int dump_only,
				 int removing,
				 struct module_options **options,
				 struct module_command **commands,
				 struct module_alias **aliases,
				 struct module_blacklist **blacklist);

int read_config_file(const char *filename,
			    const char *name,
			    int dump_only,
			    int removing,
			    struct module_options **options,
			    struct module_command **commands,
			    struct module_alias **aliases,
			    struct module_blacklist **blacklist);

int read_config_file_bin(const char *filename,
			    const char *name,
			    int dump_only,
			    int removing,
			    struct module_options **options,
			    struct module_command **commands,
			    struct module_alias **aliases,
			    struct module_blacklist **blacklist);
struct module_options *
add_options(const char *modname,
	    const char *option,
	    struct module_options *options);

char *strsep_skipspace(char **string, char *delim);
char *underscores(char *string);
struct module_alias *
add_alias(const char *modname, struct module_alias *aliases);
char *getline_wrapped(FILE *file, unsigned int *linenum);
int
find_blacklist(const char *modname, const struct module_blacklist *blacklist);

#endif /* __MODPROBE_H */
